// Generated by CoffeeScript 1.12.2
(function() {
  var CrystalIcon, DiodeIcon, FetIcon, Icon, Icons, PushbuttonIcon, ResistorIcon,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Icon = require('./icon');

  CrystalIcon = (function(superClass) {
    extend(CrystalIcon, superClass);

    function CrystalIcon(symbol, element) {
      this.width = 6;
      this.height = 8;
      CrystalIcon.__super__.constructor.call(this, symbol, element);
    }

    CrystalIcon.prototype.draw = function(x, y) {
      var d, gap, settings;
      settings = this.symbol.settings;
      gap = 1.5;
      d = 2;
      return this.symbol.lineWidth(this.lineWidth).center(x, y).rectangle(-this.width / 2 + gap, -this.height / 2, this.width / 2 - gap, this.height / 2, settings.fill).line(-this.width / 2, -this.height / 2 + d, -this.width / 2, this.height / 2 - d).line(this.width / 2, -this.height / 2 + d, this.width / 2, this.height / 2 - d).center(0, 0);
    };

    return CrystalIcon;

  })(Icon);

  DiodeIcon = (function(superClass) {
    extend(DiodeIcon, superClass);

    function DiodeIcon(symbol, element) {
      this.width = 4;
      this.height = 5;
      DiodeIcon.__super__.constructor.call(this, symbol, element);
      if (this.schematic.tvs) {
        this.width *= 2;
      }
    }

    DiodeIcon.prototype.draw = function(x, y, rotated) {
      var arrowWidth, d, f, len, settings, space, x1, x2, xa, y1, y2, ya;
      if (rotated == null) {
        rotated = false;
      }
      settings = this.symbol.settings;
      f = rotated ? -1 : 1;
      x1 = f * (-this.width / 2);
      y1 = f * (-this.height / 2);
      x2 = f * this.width / 2;
      y2 = f * this.height / 2;
      this.symbol.lineWidth(this.lineWidth).center(x, y);
      if (this.schematic.tvs) {
        d = f * 1;
        this.symbol.poly(x1, y1, 0, 0, x1, y2, x1, y1, settings.fill).poly(x2, y1, 0, 0, x2, y2, x2, y1, settings.fill).line(0, y1, 0, y2).line(0, y1, -d, y1 - d).line(0, y2, d, y2 + d);
      } else {
        this.symbol.poly(x1, y1, x2, 0, x1, y2, x1, y1, settings.fill).line(x2, y1, x2, y2);
        if (this.schematic.schottky) {
          d = f * 1;
          this.symbol.moveTo(x2, y2).lineTo(x2 - d, y2).lineTo(x2 - d, y2 - d).moveTo(x2, y1).lineTo(x2 + d, y1).lineTo(x2 + d, y1 + d);
        } else if (this.schematic.zener) {
          d = f * 1;
          this.symbol.line(x2, y1, x2 - d, y1 - d).line(x2, y2, x2 + d, y2 + d);
        } else if (this.schematic.led) {
          space = 1;
          d = f * 1.5;
          len = f * 3;
          arrowWidth = 1;
          xa = Math.max(this.width, this.height) / 2;
          ya = -xa;
          x1 = xa;
          y1 = ya - d;
          x2 = xa + d;
          y2 = ya;
          this.symbol.line(x1, y1, x1 + len, y1 - len).arrow(x1 + len / 2, y1 - len / 2, x1 + len, y1 - len, arrowWidth).line(x2, y2, x2 + len, y2 - len).arrow(x2 + len / 2, y2 - len / 2, x2 + len, y2 - len, arrowWidth);
        }
      }
      return this.symbol.center(0, 0);
    };

    return DiodeIcon;

  })(Icon);

  FetIcon = (function(superClass) {
    extend(FetIcon, superClass);

    function FetIcon(symbol, element) {
      var height, width;
      width = 15;
      height = 9;
      this.width = 2 * symbol.alignToGrid(width / 2, 'ceil');
      this.height = 2 * symbol.alignToGrid(height / 2, 'ceil');
      FetIcon.__super__.constructor.call(this, symbol, element);
    }

    FetIcon.prototype.draw = function(x, y) {
      var arrowWidth, dx, gap, h, i, j, l, space, w;
      space = 1.5;
      gap = 1;
      arrowWidth = 1.5;
      dx = this.schematic.diode && (!this.schematic.jfet) ? -this.width / 8 : 0;
      this.symbol.lineWidth(this.lineWidth).center(x, y);
      if (this.schematic.depletion || this.schematic.jfet) {
        this.symbol.line(dx, -this.height / 2, dx, this.height / 2);
      } else {
        y = -this.height / 2;
        l = (this.height - 2 * gap) / 3;
        for (i = j = 1; j <= 3; i = ++j) {
          this.symbol.line(dx, y, dx, y + l);
          y += l + gap;
        }
      }
      y = (this.height + gap) / 3;
      this.symbol.line(dx, y, this.width / 2, y).line(this.width / 2, y, this.width / 2, this.height / 2).line(dx, -y, this.width / 2, -y).line(this.width / 2, -y, this.width / 2, -this.height / 2);
      if (this.schematic.jfet) {
        this.symbol.line(-this.width / 2, this.height / 2, dx, this.height / 2);
        if (this.schematic.n) {
          this.symbol.poly(dx - this.width / 8, this.height / 2 + arrowWidth / 2, dx, this.height / 2, dx - this.width / 8, this.height / 2 - arrowWidth / 2, 'background');
        }
        if (this.schematic.p) {
          this.symbol.poly(dx - this.width / 4, this.height / 2, dx - this.width / 8, this.height / 2 + arrowWidth / 2, dx - this.width / 8, this.height / 2 - arrowWidth / 2, 'background');
        }
      } else {
        this.symbol.line(-this.width / 2, this.height / 2, dx - space, this.height / 2).line(dx - space, -this.height / 2, dx - space, this.height / 2).line(dx, 0, dx + this.width / 4, 0).line(dx + this.width / 4, 0, dx + this.width / 4, (this.height + gap) / 3);
        if (this.schematic.n) {
          this.symbol.poly(dx, 0, dx + this.width / 8, arrowWidth / 2, dx + this.width / 8, -arrowWidth / 2, 'background');
        }
        if (this.schematic.p) {
          this.symbol.poly(dx + this.width / 8, arrowWidth / 2, dx + this.width / 4, 0, dx + this.width / 8, -arrowWidth / 2, 'background');
        }
      }
      if (this.schematic.diode) {
        x = this.width / 8 + space;
        w = this.width / 8;
        h = w / 2 * Math.tan(Math.PI / 3);
        this.symbol.line(x + w / 2, -(this.height + gap) / 3, x + w / 2, -h / 2).line(x + w / 2, h / 2, x + w / 2, (this.height + gap) / 3);
        if (this.schematic.n) {
          this.symbol.polyline(x, h / 2, x + w, h / 2, x + w / 2, -h / 2, x, h / 2).line(x, -h / 2, x + w, -h / 2);
        } else if (this.schematic.p) {
          this.symbol.polyline(x, -h / 2, x + w, -h / 2, x + w / 2, h / 2, x, -h / 2).line(x, h / 2, x + w, h / 2);
        }
      }
      return this.symbol.center(0, 0);
    };

    return FetIcon;

  })(Icon);

  PushbuttonIcon = (function(superClass) {
    extend(PushbuttonIcon, superClass);

    function PushbuttonIcon(symbol, element) {
      this.width = 10;
      this.height = 8;
      PushbuttonIcon.__super__.constructor.call(this, symbol, element);
    }

    PushbuttonIcon.prototype.draw = function(x, y) {
      var r;
      r = 1;
      return this.symbol.lineWidth(this.lineWidth).center(x, y).circle(-this.width / 2 + r, this.height / 2 - r, r).circle(this.width / 2 - r, this.height / 2 - r, r).line(-this.width / 2, 0, this.width / 2, 0).line(0, 0, 0, -this.height / 2).center(0, 0);
    };

    return PushbuttonIcon;

  })(Icon);

  ResistorIcon = (function(superClass) {
    extend(ResistorIcon, superClass);

    function ResistorIcon(symbol, element) {
      this.width = 10;
      this.height = 4;
      ResistorIcon.__super__.constructor.call(this, symbol, element);
      if (this.schematic.trimpot) {
        this.space = this.height / 2;
      }
    }

    ResistorIcon.prototype.draw = function(x, y) {
      var d, settings;
      settings = this.symbol.settings;
      this.symbol.lineWidth(this.lineWidth).center(x, y).rectangle(-this.width / 2, -this.height / 2, this.width / 2, this.height / 2, settings.fill);
      if (this.schematic.trimpot) {
        d = 1;
        this.symbol.line(-this.height, this.height, this.height, -this.height).line(this.height - d, -this.height - d, this.height + d, -this.height + d);
      }
      return this.symbol.center(0, 0);
    };

    return ResistorIcon;

  })(Icon);

  Icons = {};

  Icons.Crystal = CrystalIcon;

  Icons.Diode = DiodeIcon;

  Icons.Fet = FetIcon;

  Icons.Pushbutton = PushbuttonIcon;

  Icons.Resistor = ResistorIcon;

  module.exports = Icons;

}).call(this);
